unit MainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, GraphFormU, SideBarFormU, SerialNG, Menus,
  CoolTrayIcon;
// SynaSer
type
  TMainForm = class(TForm)
    Sheet1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox4: TGroupBox;
    Label7: TLabel;
    lblManufacturer: TLabel;
    lblModel: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lblRelease: TLabel;
    lblSerial: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    lblBStatus: TLabel;
    lblBVolt: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lblBCapa: TLabel;
    lblBCurrent: TLabel;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    lblOStatus: TLabel;
    lblVoltOut: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lblOPower: TLabel;
    lblOLoad: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    lblBadInputs: TLabel;
    Label2: TLabel;
    lblVoltIn: TLabel;
    Label4: TLabel;
    lblRangeIn: TLabel;
    Label3: TLabel;
    lblIPower: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    UpdateInterval: TEdit;
    btnSaveINI: TButton;
    lblStatus: TLabel;
    DelayTimer: TTimer;
    AutoPollTimer: TTimer;
    ser: TSerialPortNG;
    RxTimeout: TTimer;
    COM: TEdit;
    lblEvent: TLabel;
    GroupBox5: TGroupBox;
    lblRuntime: TLabel;
    Label19: TLabel;
    lblBPVolt: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    lblBPPower: TLabel;
    Label20: TLabel;
    ExtraDelay: TTrackBar;
    Label21: TLabel;
    CharDelay: TTrackBar;
    Label23: TLabel;
    TabSheet4: TTabSheet;
    log: TMemo;
    TX: TEdit;
    RX: TEdit;
    GroupBox8: TGroupBox;
    Button2: TButton;
    Label28: TLabel;
    StartUpDelay: TEdit;
    GroupBox9: TGroupBox;
    Label29: TLabel;
    Button3: TButton;
    ShutDownDelay: TEdit;
    SShutdownO: TRadioButton;
    SShutdownS: TRadioButton;
    Label30: TLabel;
    Panel1: TPanel;
    SVoltage: TRadioGroup;
    SFreq: TRadioGroup;
    SBuzzer: TRadioGroup;
    GroupBox7: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    SBypass: TCheckBox;
    SNoLoad: TCheckBox;
    SBCapa: TEdit;
    GroupBox6: TGroupBox;
    SModem: TEdit;
    bSSave: TButton;
    GroupBox10: TGroupBox;
    Label31: TLabel;
    Button4: TButton;
    RebootDelay: TEdit;
    Label32: TLabel;
    SNumReceptacles: TLabel;
    Label27: TLabel;
    SEnReceptacles: TCheckBox;
    SAutoRestart: TCheckBox;
    GroupBox11: TGroupBox;
    Label33: TLabel;
    lblTestStatus: TLabel;
    Button1: TButton;
    Button5: TButton;
    CoolTray: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    Show1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Sidebar1: TMenuItem;
    Stayontop1: TMenuItem;
    Showhide1: TMenuItem;
    Sidebars1: TMenuItem;
    GasOMeter1: TMenuItem;
    Stayontop2: TMenuItem;
    Showhide2: TMenuItem;
    Savewindowsettings1: TMenuItem;
    Mainwindow1: TMenuItem;
    Stayontop3: TMenuItem;
    Showhide3: TMenuItem;
    Recoverlostwindows1: TMenuItem;
    GroupBox12: TGroupBox;
    SystemShutDownEnabled: TCheckBox;
    SystemShutDownDelay: TEdit;
    ShutdownTimer: TTimer;
    ShutdownProgress: TProgressBar;
    Label34: TLabel;
    procedure InitVars;
    procedure UPSConnect(COM:String);
    Procedure CheckUPS;
    Procedure PollUPS;
    Function QueryUPS(cmd:string;command:boolean=false):String;
    function cStrToInt(s:string):LongInt;
    procedure InitProgram;
    procedure UpdateIntervalExit(Sender: TObject);
    procedure DelayTimerTimer(Sender: TObject);
    procedure AutoPollTimerTimer(Sender: TObject);
    Procedure UpdateValues;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSaveINIClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RxTimeoutTimer(Sender: TObject);
    Function StringRX:String;
    procedure serRxEventCharEvent(Sender: TObject);
    procedure serRxClusterEvent(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Sheet1Change(Sender: TObject);
    procedure TabSheet4Show(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure TabSheet1Hide(Sender: TObject);
    procedure serProcessError(Sender: TObject; Place, Code: Cardinal;
      Msg: String);
    procedure bSSaveClick(Sender: TObject);
    procedure Logfile(s:string);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Showhide1Click(Sender: TObject);
    procedure Showhide2Click(Sender: TObject);
    procedure ConfigRead;
    procedure ConfigWrite;
    procedure Savewindowsettings1Click(Sender: TObject);
    procedure Stayontop3Click(Sender: TObject);
    procedure Stayontop1Click(Sender: TObject);
    procedure Stayontop2Click(Sender: TObject);
    procedure Showhide3Click(Sender: TObject);
    procedure Recoverlostwindows1Click(Sender: TObject);
    procedure ShutdownTimerTimer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure COMExit(Sender: TObject);
    procedure ExtraDelayChange(Sender: TObject);
    procedure CharDelayChange(Sender: TObject);
    procedure WriteStatus;
  private
    { Private-Deklarationen }
    //ser:TBlockSerial;
    UPSConnected:Boolean;
    IMV_Protocols:String;
    AutoPoll,Startup:Boolean;
    rxtimeoutCounter:Word;
    fstatus:textfile;


  public
    { Public-Deklarationen }
  end;

     tStringArray = Array of String;

     tUPSSettings = Record
      ModemNumber:String[50];
      Buzzer,vZ2c_Bitmap,OVolt,OFreq,BCapa : LongInt;
     end;

     tUPS = record
      Model,
      SN,
      Release,
      Manufacturer:string[100];
      OpTime, BypassU, BypassP, Event:longint;
      BypassI:Single;
      PowerIndex:Byte;
      Settings:tUPSSettings;
     end;

     tUPSval = record
      IBad, IVolt, IPwr, IVmin, IVmax:longint;
      IFreq, ICurr:single;
      OStat, OVolt, OPwr, OLoad:longint;
      OFreq, OCurr:single;
      BStat, BTime, BCapa, BTemp:longint;
      BVolt, BCurr:single;
     end;

     tConfig = record
      Window:Array[1..3] of record
       top,left,width,height:longint;
       visible,stayontop:boolean;
      end;
      com:string[10];
      CharDelay,ExtraDelay,PollDelay:Longint;
      eventfile,statusfile:string[255];
     end;

Const MaxPower:Array[1..7] of Word = (360,600,900,1200,1800,2400,4000);
      Batteries:Array[1..7] of Word = (2,3,4,6,9,10,20);
      // 600, 1000, 1500, 2000, 3000, 4000, 5000 VA UPS TYPE
      BatteryVolt = 13.8;

      ConfigFile:String='NetProUPS.ini';
      Version='NetProUPS/win32/v1.00';

var
  MainForm: TMainForm;
  UPS:tUPS;
  UPS_Val:tUPSval;
  TimeOut,TabChangeAllowed,UPS_Attention,CloseAllowed:Boolean;
  RXBuf:String;
  cfg:tconfig;

implementation

uses IniFiles;

{$R *.DFM}


procedure TMainForm.ConfigWrite;
var ini:tinifile;
    i:word;
begin
 ini:=tinifile.create(ConfigFile);

 for i:=1 to 3 do begin
  ini.WriteInteger('Window'+inttostr(i),'Top',cfg.Window[i].top);
  ini.WriteInteger('Window'+inttostr(i),'Left',cfg.Window[i].left);
  ini.WriteInteger('Window'+inttostr(i),'Width',cfg.Window[i].width);
  ini.WriteInteger('Window'+inttostr(i),'Height',cfg.Window[i].height);
  ini.WriteBool('Window'+inttostr(i),'Visible',cfg.Window[i].Visible);
  ini.WriteBool('Window'+inttostr(i),'StayOnTop',cfg.Window[i].StayOnTop);
 end;

 ini.WriteString('Files','EventFile',cfg.eventfile);
 ini.WriteString('Files','StatusFile',cfg.Statusfile);

 ini.WriteString('COMM','Port',cfg.com);
 ini.WriteInteger('COMM','CharDelay',cfg.chardelay);
 ini.WriteInteger('COMM','ExtraDelay',cfg.extradelay);
 ini.WriteInteger('COMM','PollDelay',cfg.Polldelay);

 ini.writeinteger('Main','SystemShutDownDelay',strtoint(SystemShutDownDelay.text));
 ini.writebool('Main','SystemShutDownEnabled',SystemShutDownEnabled.checked);

 ini.free;
end;

procedure TMainForm.ConfigRead;
var ini:tinifile;
    i:word;
begin
 ini:=tinifile.create(ConfigFile);

 for i:=1 to 3 do begin
  cfg.Window[i].top      := ini.ReadInteger('Window'+inttostr(i),'Top',10);
  cfg.Window[i].left     := ini.ReadInteger('Window'+inttostr(i),'Left',10);
  cfg.Window[i].width    := ini.ReadInteger('Window'+inttostr(i),'Width',450);
  cfg.Window[i].height   := ini.ReadInteger('Window'+inttostr(i),'Height',150);
  cfg.Window[i].Visible  := ini.ReadBool('Window'+inttostr(i),'Visible',true);
  cfg.Window[i].StayOnTop:= ini.ReadBool('Window'+inttostr(i),'StayOnTop',false);
 end;

 cfg.eventfile           := ini.readString('Files','EventFile','eventlog.txt');
 cfg.Statusfile          := ini.readString('Files','StatusFile','statuslog.csv');

 cfg.com                 := ini.readString('COMM','Port','COM1');
 cfg.chardelay           := ini.readInteger('COMM','CharDelay',43);
 cfg.extradelay          := ini.readInteger('COMM','ExtraDelay',100);
 cfg.Polldelay           := ini.readInteger('COMM','PollDelay',1);

 SystemShutDownDelay.text:=inttostr(ini.readinteger('Main','SystemShutDownDelay',150));
 SystemShutDownEnabled.checked:=ini.readbool('Main','SystemShutDownEnabled',false);


 ini.free;

 Top := cfg.window[1].top;
 Left := cfg.window[1].left;
 FormStyle := fsNormal;
 if cfg.window[1].StayOnTop then FormStyle := fsStayOnTop;
 stayontop3.Checked := cfg.window[1].StayOnTop;

 sidebarform.Top := cfg.window[2].top;
 sidebarform.left := cfg.window[2].left;
 sidebarform.FormStyle := fsNormal;
 if cfg.window[2].StayOnTop then sidebarform.FormStyle := fsStayOnTop;
 stayontop2.Checked := cfg.window[2].StayOnTop;


 graphform.Top := cfg.window[3].top;
 graphform.left := cfg.window[3].left;
 graphform.width := cfg.window[3].width;
 graphform.height := cfg.window[3].height;
 graphform.FormStyle := fsNormal;
 if cfg.window[3].StayOnTop then graphform.FormStyle := fsStayOnTop;
 stayontop1.Checked := cfg.window[3].StayOnTop;

 com.text := cfg.com;
 updateinterval.text := inttostr(cfg.polldelay);
 extradelay.position := cfg.extradelay;
 chardelay.position := cfg.chardelay;

 DelayTimer.Interval := strtoint(UpdateInterval.text)*1000;
end;


function BStatusTxt(n:longint):string;
var s:string;
begin
 case n of
      -1: s:='N/A';
       2: s:='Normal';
       3: s:='Depleted';

  else s:='Unknown ('+inttostr(n)+')';
 end;
 BStatusTxt := s;
end;

function OStatusTxt(n:longint):string;
var s:string;
begin
 case n of
      -1: s:='N/A';
       2: s:='Offline';
       3: s:='On Line';
       5: s:='On Battery';
  else s:='Unknown ('+inttostr(n)+')';
 end;
 OStatusTxt := s;
end;

function EventTxt(n:longint):string;
var s:string;
begin
 case n of
      -1: s:='N/A (lost communication)';
       0: s:='Normal operation';
   24576: s:='UPS powered off';
     512: s:='Input ok, On Battery';
     546: s:='Input+Bypass bad, On Battery';
 8388608: s:='Test running';
       1: s:='Change Battery';
  else s:='Unknown ('+inttostr(n)+')';
 end;
 EventTxt := s;
end;



procedure TMainForm.UPSConnect(COM:String);
var s:string;
begin
  lblstatus.Caption:='Connecting...';
  application.processmessages;
  try
    logfile('Connecting '+COM);
//    ser.Connect(COM);
//    ser.Config(1200,8,'N',0,false,false);
    s:=QueryUPS('');
//    s:=ser.Recvstring(1000);
    s:=QueryUPS('');
//    s:=trim(ser.Recvstring(1000));
    s:=QueryUPS('');
    log.lines.add('IMV Protocol Version: '+s);
    if pos(s,IMV_Protocols)<1 then begin
     logfile('Unknown protocol or no Victron UPS connected!');
     UPSConnected:=False;
    end else UPSConnected:=True;
  except
//    log.lines.add(ser.lasterrordesc);
      log.lines.add('Error opening comm port...');
  end;
  lblstatus.Caption:='Connected';
end;

Procedure TMainForm.InitVars;
begin
    UPSConnected:=False;
    IMV_Protocols:='4.06 3.00'; // Supported protocol versions (space separated)
    AutoPoll:=False;
    TabChangeAllowed:=false;
    UPS_Attention:=false;
    CloseAllowed:=false;
    ConfigFile:=ExtractFilePath(paramstr(0))+'\'+ConfigFile;
end;

Function TMainForm.QueryUPS(cmd:string;command:boolean=false):String;
var s:string;
begin
    s:=cmd;
    if command then s:=s+'!'+chr(13) else s:=cmd+'?'+chr(13);
    tx.text:=s;
  try
    ser.SendString(s);
    s:=trim(StringRX());
    S:=copy(s,length(cmd)+1,200);
  except
    s:='ERR: QueryUPS';
    logfile(s);
  end;
  QueryUPS:=S;
end;

Procedure TMainForm.CheckUPS;
Begin
 ups.Model   := QueryUPS('vDM');
 ups.SN      := QueryUPS('vDS');
 ups.Release := QueryUPS('vDV');
 ups.Manufacturer := QueryUPS('vDm');

 lblManufacturer.caption:=ups.manufacturer;
 lblModel.caption:=ups.model;
 lblSerial.caption:=ups.SN;
 lblRelease.caption:=ups.release;

 // Set maximum output Power
 ups.PowerIndex:=0;
 If Pos(' 600',ups.model)>0 then ups.PowerIndex:=1;
 If Pos(' 1000',ups.model)>0 then ups.PowerIndex:=2;
 If Pos(' 1500',ups.model)>0 then ups.PowerIndex:=3;
 If Pos(' 2000',ups.model)>0 then ups.PowerIndex:=4;
 If Pos(' 3000',ups.model)>0 then ups.PowerIndex:=5;
 If Pos(' 4000',ups.model)>0 then ups.PowerIndex:=6;
 If ups.model='D5-11' then ups.PowerIndex:=7;
 If Ups.PowerIndex = 0 then ups.PowerIndex:=7;

 SideBarForm.Analog3.Max := MaxPower[ups.PowerIndex]+(MaxPower[ups.PowerIndex]*0.2);
 SideBarForm.Analog4.Min := (Batteries[ups.PowerIndex]*BatteryVolt) - (Batteries[ups.PowerIndex]*2) - 5;
 SideBarForm.Analog4.Max := (Batteries[ups.PowerIndex]*BatteryVolt) + (Batteries[ups.PowerIndex]*2) + 5;

 SideBarForm.analog1.TickCount:= Round(Round(SideBarForm.Analog1.Max-SideBarForm.Analog1.Min)/10);
 SideBarForm.analog2.TickCount:= Round(Round(SideBarForm.Analog2.Max-SideBarForm.Analog2.Min)/10);
 SideBarForm.analog3.TickCount:= Round(Round(SideBarForm.Analog3.Max-SideBarForm.Analog3.Min)/100);
 SideBarForm.analog4.TickCount:= Round(SideBarForm.Analog4.Max-SideBarForm.Analog4.Min);
end;

procedure TMainForm.PollUPS;
begin
 lblstatus.Caption:='Polling UPS...';
 application.processmessages;
 // INPUT STATUS
 ups_val.IBad  := cstrtoint(QueryUPS('vIB'));
 ups_val.IFreq := cstrtoint(QueryUPS('vI0f'))/10;
 ups_val.IVolt := cstrtoint(QueryUPS('vI0U'));
 ups_val.ICurr := cstrtoint(QueryUPS('vI0I'))/10;
 ups_val.IPwr  := cstrtoint(QueryUPS('vI0P'));
 ups_val.IVmin := cstrtoint(QueryUPS('vI0l'));
 ups_val.IVmax := cstrtoint(QueryUPS('vI0h'));

 // OUTPUT STATUS
 ups_val.OStat := cstrtoint(QueryUPS('vOs'));
 ups_val.OFreq := cstrtoint(QueryUPS('vOf'))/10;
 ups_val.OVolt := cstrtoint(QueryUPS('vO0U'));
 ups_val.OCurr := cstrtoint(QueryUPS('vO0I'))/10;
 ups_val.OPwr  := cstrtoint(QueryUPS('vO0P'));
 ups_val.OLoad := cstrtoint(QueryUPS('vO0L'));

 // BATTERY STATUS
 ups_val.BStat := cstrtoint(QueryUPS('vBs'));
 ups_val.BTime := cstrtoint(QueryUPS('vBt'));
 ups_val.BVolt := cstrtoint(QueryUPS('vBU'))/10;
 ups_val.BCapa := cstrtoint(QueryUPS('vBC'));
 ups_val.BCurr := cstrtoint(QueryUPS('vBI'))/10;
 ups_val.BTemp := cstrtoint(QueryUPS('vBT'));

 // MISC UPS STATUS
 ups.OpTime := cstrtoint(QueryUPS('vZa')); // seconds
 ups.BypassU := cstrtoint(QueryUPS('vP0U'));
 ups.BypassI := cstrtoint(QueryUPS('vP0I'))/10;
 ups.BypassP := cstrtoint(QueryUPS('vP0P'));

 if ups_attention = false then begin
  ups.Event := cstrtoint(QueryUPS('vAa'));
  lblevent.caption:=EventTxt(ups.event);
 end;


 lblstatus.Caption:='Idle';
// application.processmessages;
// if ups.event <> 0 then UPS_Event;
end;


function tMainForm.cStrToInt(s:string):LongInt;
begin
 try
  cStrToInt := strtoint(s);
 except
  On E : EConvertError do cStrToInt:=-1;
 end;
end;

Function StrToArray(str:string;Delim:Char):TStringArray;
Var A:TStringArray;
    I,y:Word;
    s:string;
Begin
 i:=1;
 s:=str+delim;
 repeat
  y:=pos(delim,s);
  if y>0 then begin
   SetLength(A, i);
   A[i-1]:=copy(s,0,y-1);
   delete(s,1,y);
   inc(i);
  end;
 until y<1;
 StrToArray := A;
end;

procedure TMainForm.InitProgram;
begin
 ConfigRead;

 ser.Active  := false;
 ser.CommPort:=COM.text;
 ser.RTOExtraDelayTime := extradelay.Position;
 ser.WTOExtraDelayTime := extradelay.Position;
 ser.WTOCharDelayTime := chardelay.Position;
 ser.RTOCharDelayTime := chardelay.Position;

 ser.Active  := true;


 UPSConnect(COM.text);
 if UPSConnected then begin
  CheckUPS;
  DelayTimer.enabled:=true;
 end else begin
  lblStatus.caption:='Error!';
  DelayTimer.enabled:=False;
 end;
end;

Procedure TMainForm.UpdateValues;
Begin
   lblBadInputs.caption:=InttoStr(ups_val.IBad);
   lblVoltIn.caption:=Format('%dV @ %3.1f Hz',[ups_val.IVolt,ups_val.IFreq]);
   lblRangeIn.caption:=Format('%dV - %dV',[ups_val.IVMin,ups_val.ivmax]);
   lblIPower.caption:=Format('%d Watts (%4.2f A)',[ups_val.IPwr,ups_val.ICurr]);

   lblBStatus.caption:=format('%s / %dC',[BStatusTxt(ups_val.BStat),ups_val.BTemp]);
   lblBVolt.caption:=format('%4.2fV DC',[ups_val.BVolt]);
   lblBCurrent.caption:=format('%4.2f A',[ups_val.BCurr]);
   lblBCapa.caption:=format('%d min (%d%s)',[ups_val.BTime,ups_val.BCapa,'%']);


   lblOStatus.caption:=OStatusTxt(ups_val.OStat);
   lblVoltOut.caption:=Format('%dV @ %3.1f Hz',[ups_val.OVolt,ups_val.OFreq]);
   lblOLoad.caption:=Format('%d%s',[ups_val.OLoad,'%']);
   lblOPower.caption:=Format('%d Watts (%4.2f A)',[ups_val.OPwr,ups_val.OCurr]);

   lblRuntime.Caption:=Format('%1.2f Hours',[ups.optime/3600]);
   lblBPVolt.Caption :=format('%dV',[ups.BypassU]);
   lblBPPower.Caption :=Format('%d Watts (%4.2f A)',[ups.BypassP,ups.BypassI]);

end;

procedure TMainForm.UpdateIntervalExit(Sender: TObject);
begin
 if strtoint(UpdateInterval.text)<0 then UpdateInterval.text:='0';
 cfg.PollDelay := strtoint(updateinterval.text);
end;

procedure TMainForm.DelayTimerTimer(Sender: TObject);
begin
 AutoPoll:=True;
 AutoPollTimer.Enabled:=true;
 DelayTimer.Enabled :=False;
end;

procedure TMainForm.AutoPollTimerTimer(Sender: TObject);
var event:longint;
    s:string;
begin
 if UPS_Attention then begin
  autoPollTimer.enabled:=false;
  ups_attention:=false;
  event:=ups.event;

  timeout:=false;
  rxtimeout.enabled:=true;
  repeat application.processmessages until timeout;

  ups.Event := cstrtoint(QueryUPS('vAa'));
  s:='UPS Status changed from "'+EventTxt(event)+'" to "'+EventTxt(ups.event)+'" !';
  Logfile(s);
  autoPollTimer.enabled:=true;
 end;

if SystemShutDownEnabled.checked then begin
 if (ups.Event <2) and shutdowntimer.Enabled then begin
  ShutdownTimer.Enabled:=false;
  delaytimer.Interval := cfg.PollDelay*1000;
  ShutdownProgress.Position:=0;
  log.lines.add('Stopping ShutDownTimer');
 end;
 if (ups.Event >1) and not shutdowntimer.Enabled then begin
  sheet1.ActivePage := TabSheet1;
  ShutdownProgress.Max := strtoint(SystemShutDownDelay.text);
  delaytimer.Interval := 500;
  ShutdownTimer.Enabled:=true;
  log.lines.add('Starting ShutDownTimer: '+inttostr(ShutdownProgress.Max)+' seconds');
 end;
end;


 if not AutoPoll then exit;
 autoPollTimer.enabled:=false;

 if UPSConnected then begin
  PollUPS;
  UpdateValues;
  WriteStatus;

  // Update Graph
  GraphForm.Voltages.AddPoint(0, round(ups_val.iVolt) , 'Input Voltage');
  GraphForm.Voltages.AddPoint(1, round(ups_val.oVolt) , 'Output Voltage');
  GraphForm.Voltages.AddPoint(2, round(ups_val.bVolt) , 'Battery Voltage');
  GraphForm.Power.AddPoint(0, round(ups_val.iPwr) , 'Input Power');
  GraphForm.Power.AddPoint(1, round(ups_val.oPwr) , 'Output Power');

  // Update Gauges
  SideBarForm.Analog1.value := ups_val.iVolt;
  SideBarForm.Analog2.value := ups_val.oVolt;
  SideBarForm.Analog3.value := ups_val.oPwr;
  SideBarForm.Analog4.value := ups_val.bVolt;
  SideBarForm.Analog5.value := ups_val.oLoad;

 end else lblStatus.Caption := 'Not connected !';

 autoPollTimer.enabled:=true;

 if autopoll then begin
  AutoPoll:=False;
  DelayTimer.Enabled := True;
 end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if not CloseAllowed then begin
  // minimize to tray
  //cooltray.MinimizeToTray := true;
  Action:=caNone;
  //application.Minimize;
  cooltray.HideMainForm;
  if cfg.window[2].visible then sidebarform.Show else sidebarform.hide;
  if cfg.window[3].visible then graphform.show else graphform.hide;
  exit;
 end;

 try
  ser.ClearTxDQueue;
  ser.ClearRxDQueue;
  ser.Active := false;
  // ser.free;
 except
  log.lines.add('jaja... fehler, ich weiss...');
 end;

 logfile('Program Exit');

end;

procedure TMainForm.btnSaveINIClick(Sender: TObject);
begin
 ConfigWrite;
 Sheet1.ActivePage:=TabSheet1;
 InitProgram;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 log.lines.add(version);
 chdir(extractfilepath(paramstr(0)));
 INITVars;
// Ser.Active := True;
 StartUp := true;
 ShutDownTimer.enabled := true;
 Sheet1.ActivePage:=TabSheet2;
// Cooltray.HideMainForm;
 cooltray.ShowBalloonHint('NetPro','Connecting to UPS, please wait...',bitinfo,20);
end;

procedure TMainForm.RxTimeoutTimer(Sender: TObject);
begin
 dec(rxtimeoutCounter);
 if rxtimeoutCounter<=0 then begin
  TimeOut:=True;
  RxTimeOut.enabled:=false;
 end;
end;

Function TMainForm.StringRX:String;
begin
 RXBUF:='';
 TimeOut:=False;
 rxtimeoutCounter:=6;
 RxTimeOut.Enabled:=True;
 while (not TimeOut) AND (POS(#13,RXBUF)<1) do begin
//  application.processmessages;
  application.HandleMessage;
  if ser.Active = false then exit;
 end;
 rx.Text:=Copy(trim(RXBUF),0,pos(#13,RXBUF)-1);
 StringRX:=rx.text;
end;


procedure TMainForm.serRxClusterEvent(Sender: TObject);
var s:string;
begin
  if Ser.NextClusterSize >= 0 then
    begin
     s:=ser.ReadNextClusterAsString;
     if length(RXBUF)>8192 then RXBUF:='';
     RXBUF:=RXBUF+s;
    end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
 GraphForm.Show;
 SideBarForm.Show;
end;

procedure TMainForm.FormHide(Sender: TObject);
begin
 GraphForm.Hide;
 SideBarForm.Hide;
end;

procedure TMainForm.Sheet1Change(Sender: TObject);
begin
 if not TabChangeAllowed then  Sheet1.ActivePage:=TabSheet2;
end;

procedure TMainForm.TabSheet4Show(Sender: TObject);
var r:real;
begin
 log.lines.add('Reading UPS Settings...');
 QueryUPS('');
 QueryUPS('');

 Ups.Settings.OFreq := cstrtoint(QueryUPS('vFd'));
 Ups.Settings.OVolt := cstrtoint(QueryUPS('vFc'));
 Ups.Settings.Buzzer := cstrtoint(QueryUPS('vFh'));
 Ups.Settings.BCapa := cstrtoint(QueryUPS('vFk'));
 Ups.Settings.ModemNumber := QueryUPS('vZ0d');
 QueryUPS('vCC5424107',true);
 Ups.Settings.vZ2c_BitMap := cstrtoint(QueryUPS('vZ2c'));

 SNoLoad.Checked := (ups.settings.vZ2c_Bitmap AND 4) = 4;
 SByPass.Checked := (ups.settings.vZ2c_Bitmap AND 2) = 2;

 case ups.settings.OVolt of
  220:  svoltage.ItemIndex:= 0;
  230:  svoltage.ItemIndex:= 1;
  240:  svoltage.ItemIndex:= 2;
 else
  svoltage.ItemIndex:= -1;
 end;

 case ups.settings.OFreq of
  500:  sfreq.ItemIndex:=0;
  600:  sfreq.ItemIndex:=1;
 else
  sfreq.ItemIndex:=-1;
 end;

 sbuzzer.ItemIndex := ups.settings.Buzzer-1;

 smodem.text:=ups.Settings.ModemNumber;
 smodem.Enabled := smodem.text <> 'NA';

 r:=ups.Settings.Bcapa/10;
 sbcapa.Text :=format('%1.1f',[r]);

 SNumReceptacles.Caption := QueryUPS('vCn');
 SEnReceptacles.Checked := QueryUPS('vC0f')='1';
 SAutoRestart.Checked := QueryUPS('vCe')='1';
 if QueryUPS('vCa') = '1' then
  SShutdownO.checked:=true
  else
  SShutdownS.checked:=true;
 ShutdownDelay.Text := QueryUPS('vCb'); 


end;

procedure TMainForm.TabSheet1Show(Sender: TObject);
begin
 if upsconnected then begin
  delaytimer.Enabled:=true;
 end;
end;

procedure TMainForm.TabSheet1Hide(Sender: TObject);
begin
  delaytimer.Enabled:=False;
  AutoPoll:=false;
end;

procedure TMainForm.serProcessError(Sender: TObject; Place, Code: Cardinal;
  Msg: String);
begin
 log.lines.add('COM: '+Msg);
end;

procedure TMainForm.bSSaveClick(Sender: TObject);
var i:longint;
    r:real;
    s:string;
begin
 if messagedlg('Output voltage/frequency changes will be applied immediately! Are you sure?',mtConfirmation,[mbyes,mbno],0)=mrno then exit;

 QueryUPS('vCC5424107',true);
 i := cstrtoint(QueryUPS('vZ2c'));
 if i>0 then begin
  i:=i AND 249; // disable both bits first
  if SNoLoad.Checked then i:=i or 4;
  if SByPass.Checked then i:=i or 2;
  QueryUPS('vCC5424107',true);
  s:='vZ2c'+inttostr(i);
  QueryUPS(s,true);
 end;

 case svoltage.ItemIndex of
  0: QueryUPS('vFc220',true);
  1: QueryUPS('vFc230',true);
  2: QueryUPS('vFc240',true);
 end;

 case sfreq.ItemIndex of
  0: QueryUPS('vFd500',true);
  1: QueryUPS('vFd600',true);
 end;

 if sbuzzer.ItemIndex >= 0 then
  QueryUPS('vFh'+inttostr(sbuzzer.ItemIndex+1),true);

 if cstrtoint(smodem.text)>0 then
  QueryUPS('vZ0d'+smodem.text,true);

 r:=strtofloat(sbcapa.text);
 if r<4 then r:=4;
 if r>300 then r:=300;
  if r>15 then log.lines.add('Strong battery capacity...');
  if r>50 then log.lines.add('Ultra battery capacity...');
  if r>80 then log.lines.add('Wicked battery capacity...');
  if r>100 then begin
   log.lines.add('MONSTER battery capacity ;-)');
   log.lines.add('Keep in mind that this capacity could not be good for charger''s health!');
  end;
 QueryUPS('vFk'+inttostr(round(r*10)),true);

 if SEnReceptacles.checked then
  QueryUPS('vC0f1',true)
  else
  QueryUPS('vC0f2',true);

 if SAutoRestart.checked then
  QueryUPS('vCe1',true)
  else
  QueryUPS('vCe2',true);


 TabSheet4Show(Sender);
end;

procedure TMainForm.serRxEventCharEvent(Sender: TObject);
begin
 UPS_Attention:=True;
end;

procedure TMainForm.Logfile(s:string);
var st:string;
    t:textfile;
begin
 assignfile(t,cfg.eventfile);
 if not fileexists(cfg.eventfile) then rewrite(t) else append(t);
 st:=timetostr(now()) + ': ' + s;
 writeln(t,st);
 closefile(t);
 log.lines.add(st);
end;


procedure TMainForm.Button2Click(Sender: TObject);
begin
 QueryUps('vCc'+startupdelay.text,true);
end;

procedure TMainForm.Button3Click(Sender: TObject);
var s:string;
begin
 If MessageDLG('Are you really sure?',mtConfirmation,[mbyes,mbno],0)=mrno then exit;
 if SShutdownO.Checked then s:='1';
 if SShutdownS.Checked then s:='2';
 QueryUPS('vCa'+s,true);
 QueryUPS('vCb'+shutdowndelay.text,true);
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
 If MessageDLG('UPS will shut down immediately and reboot after delay. Are you sure?',mtConfirmation,[mbyes,mbno],0)=mrno then exit;
 QueryUPS('vCd'+rebootDelay.text,true);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
 lblteststatus.font.Color := clYellow;
 lblteststatus.caption := 'Please wait...';
 QueryUPS('vTi2',true);
 QueryUPS('vTi3',true);

 while queryUPS('vAa')='8388608' do begin
  application.ProcessMessages;
 end;

 QueryUPS('vTr');
 QueryUPS('vTr');

 If QueryUPS('vTr') = '1' then begin
  lblteststatus.font.Color := clGreen;
  lblteststatus.caption := 'SYS PASSED';
 end else begin
  lblteststatus.font.Color := clRed;
  lblteststatus.caption := 'SYS FAILED ';
 end;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
 lblteststatus.font.Color := clYellow;
 lblteststatus.caption := 'Please wait...';
 QueryUPS('vTi2',true);
 QueryUPS('vTi4',true);

 while queryUPS('vAa')='8388608' do begin
  application.ProcessMessages;
 end;

 QueryUPS('vTr');
 QueryUPS('vTr');

 If QueryUPS('vTr') = '1' then begin
  lblteststatus.font.Color := clGreen;
  lblteststatus.caption := 'BAT PASSED';
 end else begin
  lblteststatus.font.Color := clRed;
  lblteststatus.caption := 'BAT FAILED ';
 end;
end;

procedure TMainForm.Show1Click(Sender: TObject);
begin
 cooltray.ShowMainForm;
 if cfg.window[2].visible then sidebarform.Show else sidebarform.hide;
 if cfg.window[3].visible then graphform.show else graphform.hide;

end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
 closeallowed:=true;
 close;
end;

procedure TMainForm.Showhide1Click(Sender: TObject);
begin
 if graphform.Visible then graphform.Hide else graphform.show;
end;

procedure TMainForm.Showhide2Click(Sender: TObject);
begin
 if sidebarform.Visible then sidebarform.Hide else sidebarform.show;
end;

procedure TMainForm.Savewindowsettings1Click(Sender: TObject);
begin
 cfg.Window[1].top:=top;
 cfg.Window[1].left:=left;
 cfg.Window[1].visible:=visible;
 if FormStyle = fsNormal then cfg.Window[1].StayOnTop:=False else cfg.Window[1].StayOnTop:=True;


 cfg.Window[2].top:=sidebarform.top;
 cfg.Window[2].left:=sidebarform.left;
 cfg.Window[2].visible:=sidebarform.visible;
 if sidebarform.FormStyle = fsNormal then cfg.Window[2].StayOnTop:=False else cfg.Window[2].StayOnTop:=True;

 cfg.Window[3].top:=graphform.top;
 cfg.Window[3].left:=graphform.left;
 cfg.Window[3].width:=graphform.width;
 cfg.Window[3].height:=graphform.height;
 cfg.Window[3].visible:=graphform.visible;
 if graphform.FormStyle = fsNormal then cfg.Window[3].StayOnTop:=False else cfg.Window[3].StayOnTop:=True;

 ConfigWrite;
end;

procedure TMainForm.Stayontop3Click(Sender: TObject);
begin
 with mainform do
  if FormStyle = fsnormal then begin
   FormStyle := fsStayOnTop;
   StayOnTop3.Checked := True;
  end else begin
   FormStyle := fsNormal;
   StayOnTop3.Checked := False;
  end;
end;

procedure TMainForm.Stayontop1Click(Sender: TObject);
begin
 with graphform do
  if FormStyle = fsnormal then begin
   FormStyle := fsStayOnTop;
   StayOnTop1.Checked := True;
  end else begin
   FormStyle := fsNormal;
   StayOnTop1.Checked := False;
  end;
end;

procedure TMainForm.Stayontop2Click(Sender: TObject);
begin
 with sidebarform do
  if FormStyle = fsnormal then begin
   FormStyle := fsStayOnTop;
   StayOnTop2.Checked := True;
  end else begin
   FormStyle := fsNormal;
   StayOnTop2.Checked := False;
  end;
end;

procedure TMainForm.Showhide3Click(Sender: TObject);
begin
 if visible then cooltray.HideMainForm else cooltray.ShowMainForm;
 if cfg.window[2].visible then sidebarform.Show else sidebarform.hide;
 if cfg.window[3].visible then graphform.show else graphform.hide;
end;

procedure TMainForm.Recoverlostwindows1Click(Sender: TObject);
begin
 top:=0;
 left:=0;
 sidebarform.top:=0;
 sidebarform.Left :=0;
 graphform.top:=0;
 graphform.left:=0;
 graphform.height:=150;
 graphform.Width := 450;
end;

procedure TMainForm.ShutdownTimerTimer(Sender: TObject);

function WindowsExit(RebootParam: Longword): Boolean;
var
   TTokenHd: THandle;
   TTokenPvg: TTokenPrivileges;
   cbtpPrevious: DWORD;
   rTTokenPvg: TTokenPrivileges;
   pcbtpPreviousRequired: DWORD;
   tpResult: Boolean;
const
   SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';
begin
   if Win32Platform = VER_PLATFORM_WIN32_NT then
   begin
     tpResult := OpenProcessToken(GetCurrentProcess(),
       TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,
       TTokenHd) ;
     if tpResult then
     begin
       tpResult := LookupPrivilegeValue(nil,
                                        SE_SHUTDOWN_NAME,
                                        TTokenPvg.Privileges[0].Luid) ;
       TTokenPvg.PrivilegeCount := 1;
       TTokenPvg.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
       cbtpPrevious := SizeOf(rTTokenPvg) ;
       pcbtpPreviousRequired := 0;
       if tpResult then
         Windows.AdjustTokenPrivileges(TTokenHd,
                                       False,
                                       TTokenPvg,
                                       cbtpPrevious,
                                       rTTokenPvg,
                                       pcbtpPreviousRequired) ;
     end;
   end;
   Result := ExitWindowsEx(RebootParam, 0) ;
end;
(*
Usage:

//Shutdown
WindowsExit(EWX_POWEROFF or EWX_FORCE) ;

//Reboot Windows
WindowsExit(EWX_REBOOT or EWX_FORCE) ;
*)

begin                 
 if startup then begin
  shutdowntimer.enabled:=false;
  InitProgram;
  TabChangeAllowed:=True;
  Sheet1.ActivePage:=TabSheet1;
  cooltray.HideBalloonHint;
  if cfg.window[1].visible then cooltray.ShowMainForm;
  if cfg.window[2].visible then sidebarform.Show else sidebarform.hide;
  if cfg.window[3].visible then graphform.show else graphform.hide;
  startup:=false;
  logfile('Program started');
  exit;
 end;

 shutdownprogress.StepIt; // .position:=ShutdownProgress.position+1;
 application.processmessages;
 if ShutdownProgress.position >= ShutdownProgress.max then begin
  logfile('Initiating shutdown after '+inttostr(ShutdownProgress.max)+' seconds...');
  WindowsExit(EWX_POWEROFF or EWX_FORCE);
 end;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
 shutdowntimer.Enabled := true;
 logfile(inttostr(shutdowntimer.interval));
end;

procedure TMainForm.COMExit(Sender: TObject);
begin
 cfg.com := com.text;
end;

procedure TMainForm.ExtraDelayChange(Sender: TObject);
begin
 ser.RTOExtraDelayTime := extradelay.Position;
 ser.WTOExtraDelayTime := extradelay.Position;
 cfg.ExtraDelay :=extradelay.Position;
end;

procedure TMainForm.CharDelayChange(Sender: TObject);
begin
 ser.RTOCharDelayTime := chardelay.position;
 ser.WTOCharDelayTime := chardelay.position;
 cfg.CharDelay  := chardelay.position;
end;

procedure TMainForm.WriteStatus;

          procedure DumpLine(num:word;einheit,cap,val:string);
          begin
           Writeln(fStatus,num,';',einheit,';',Cap,';',val);
          end;

begin
 try
  Assignfile(fStatus,cfg.statusfile);
  rewrite(fStatus);
 except
  logfile('ERR: Could not write to stats file');
  exit;
 end; 

 // dumps status report
 DumpLine(1,'','Manufacturer',ups.manufacturer);
 DumpLine(2,'','Model',ups.model);
 DumpLine(3,'','Serial No.',ups.SN);
 DumpLine(4,'','Release',ups.release);
 DumpLine(5,'','Operation Time',format('%0:.2F Days',[ups.optime / 3600 / 24]));
 DumpLine(6,'','Current Event',EventTxt(ups.Event));

 DumpLine(10,'','Bad Inputs',format('%0:.4D',[ups_val.IBad]));
 DumpLine(11,'hz','Input Frequency',format('%0:2.1F',[ups_val.IFreq]));
 DumpLine(12,'V','Input Voltage',format('%0D',[ups_val.IVolt]));
 DumpLine(13,'A','Input Current',format('%0:2.1F',[ups_val.ICurr]));
 DumpLine(14,'W','Input Power',format('%0D',[ups_val.IPwr]));

 DumpLine(20,'','Output Status',OStatusTxt(ups_val.OStat));
 DumpLine(21,'hz','Output Frequency',format('%0:2.1F',[ups_val.OFreq]));
 DumpLine(22,'V','Output Voltage',format('%0D',[ups_val.OVolt]));
 DumpLine(23,'A','Output Current',format('%0:2.1F',[ups_val.OCurr]));
 DumpLine(24,'W','Output Power',format('%0D',[ups_val.OPwr]));
 DumpLine(25,'%','Output Load',format('%0D',[ups_val.OLoad]));

 DumpLine(30,'','Battery Status',BStatusTxt(ups_val.BStat));
 DumpLine(31,'min','Battery Runtime (apx.)',format('%0D',[ups_val.BTime]));
 DumpLine(32,'V','Battery Voltage',format('%0:2.1F',[ups_val.BVolt]));
 DumpLine(33,'A','Battery Current',format('%0:2.1F',[ups_val.BCurr]));
 DumpLine(34,'C','Battery Temperature',format('%0D',[ups_val.BTemp]));
 DumpLine(35,'%','Battery Capacity',format('%0D',[ups_val.BCapa]));
 
 Closefile(fStatus);
end;





end.
