unit uHMDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uHeartMachine, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    HeartMachine1: THeartMachine;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    CheckBox2: TCheckBox;
    Panel3: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  HeartMachine1.AddPoint(0, 5, 'First');
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
  TrackBar1.Height := Panel2.Height-33;
  TrackBar2.Height := Panel2.Height-33;
  TrackBar3.Height := Panel2.Height-33;
  TrackBar4.Height := Panel2.Height-33;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Timer1.Enabled := CheckBox1.Checked;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if CheckBox2.Checked then
  begin
    TrackBar1.Position := Random(100)+1;
    TrackBar2.Position := Random(100)+1;
    TrackBar3.Position := Random(100)+1;
    TrackBar4.Position := Random(100)+1;
  end;
  HeartMachine1.AddPoint(0, 100-TrackBar1.Position, 'Track Bar 1');
  HeartMachine1.AddPoint(1, 100-TrackBar2.Position, 'Track Bar 2');
  HeartMachine1.AddPoint(2, 100-TrackBar3.Position, 'Track Bar 3');
  HeartMachine1.AddPoint(3, 100-TrackBar4.Position, 'Track Bar 4');
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Timer1.Interval := StrToInt(Edit1.Text);
end;

end.
