unit SideBarFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,AnalogMeter,
  StdCtrls, ExtCtrls;

type
  TSideBarForm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Analog1,Analog2, Analog3, Analog4, Analog5 : TAnalogMeter;
  end;

var
  SideBarForm: TSideBarForm;

implementation

{$R *.DFM}

procedure TSideBarForm.Button1Click(Sender: TObject);
begin
  Analog1 := TAnalogMeter.Create(Self);
  With Analog1 do Begin
    Parent := Panel1;
    Min := 190;
    Max := 264; //Max(Word)
    Value := 219;
    Caption:='V IN';
    Hint:='Input Voltage';
    AngularRange := 360-120; // 270;
    ShowTicksScale := False;
    ShowHint := true;
    Color := clBlack;
    font.color := clwhite;
    ValueVertAdj := -20;
    LowZone := 40;
    HighZone := 60;
    OKzoneColor := clGreen;
    HighZoneColor:=clYellow;
    LowZoneColor:=clYellow;
    KnobSize := 5;
    NeedleWidth := 1;
    TickColor := clGray;
  end;

  Analog2 := TAnalogMeter.Create(Self);
  Analog2.Parent := Panel2;
  With Analog2 do Begin
    Parent := Panel2;
    Min := 210;
    Max := 250; //Max(Word)
    Value := 219;
    Caption:='V OUT';
    Hint:='Output Voltage';
    AngularRange := 360-120; // 270;
    ShowTicksScale := False;
    ShowHint := true;
    Color := clBlack;
    font.color := clwhite;
    ValueVertAdj := -20;
    LowZone := 20;
    HighZone := 80;
    OKzoneColor := clGreen;
    HighZoneColor:=clYellow;
    LowZoneColor:=clRed;
    KnobSize := 5;
    NeedleWidth := 1;
    TickColor := clGray;
  end;

  Analog3 := TAnalogMeter.Create(Self);
  With Analog3 do Begin
    Parent := Panel3;
    Min := 0;
    Max := 400; //Max(Word)
    Value := 219;
    Caption:='PWR';
    Hint:='Output Power';
    AngularRange := 360-120; // 270;
    ShowTicksScale := False;
    ShowHint := true;
    Color := clBlack;
    font.color := clwhite;
    ValueVertAdj := -20;
    LowZone := 80;
    HighZone := 90;
    OKzoneColor := clYellow;
    HighZoneColor:=clRed;
    LowZoneColor:=clGreen;
    KnobSize := 5;
    NeedleWidth := 1;
    TickColor := clGray;
  end;

  Analog4 := TAnalogMeter.Create(Self);
  With Analog4 do Begin
    Parent := Panel4;
    Min := 0;
    Max := 400; //Max(Word)
    Value := 200;
    Caption:='VBAT';
    Hint:='Battery Voltage';
    AngularRange := 360-120; // 270;
    ShowTicksScale := False;
    ShowHint := true;
    Color := clBlack;
    font.color := clwhite;
    ValueVertAdj := -20;
    LowZone := 20;
    HighZone := 80;
    OKzoneColor := clgreen;
    HighZoneColor:=clRed;
    LowZoneColor:=clred;
    KnobSize := 5;
    NeedleWidth := 1;
    TickColor := clGray;
  end;

  Analog5 := TAnalogMeter.Create(Self);
  With Analog5 do Begin
    Parent := Panel5;
    Min := 0;
    Max := 110; //Max(Word)
    Value := 1;
    Caption:='LOAD';
    Hint:='Output Load';
    AngularRange := 360-120; // 270;
    ShowTicksScale := False;
    ShowHint := true;
    Color := clBlack;
    font.color := clwhite;
    ValueVertAdj := -20;
    LowZone := 85;
    HighZone := 90;
    OKzoneColor := clYellow;
    HighZoneColor:=clRed;
    LowZoneColor:=clGreen;
    KnobSize := 5;
    NeedleWidth := 1;
    TickColor := clGray;
  end;


end;

end.
